/*
 * CodePress regular expressions for LilyPond syntax highlighting
 */

// LilyPond
Language.syntax = [
	{ input : / *(<br|<\/P)/g, output : '<u> </u>$1' }, // end of lines
	{ input : /%(.*?)(<br|<\/P)/g, output : '<big>%$1</big>$2' }, // lilypond comments %
	{ input : /%\{(.*?)\}%/g, output : '<big>$1</big>' }, //lilypond comments %{ %}
	{ input : /(\")(.*?)(\")/g, output : '<i>$1$2$3</i>' }, // quotes
	{ input : /(\{.*?\})/g, output : '<em>$1</em>' }, // blocs
	{ input : /(&lt;&lt;|&gt;&gt;)/g, output : '<span>$1</span>'}, // polyphony
	{ input : /(staff-spacing-interface|text-script-interface|Ottava_spanner_engraver|Figured_bass_engraver|Lyrics|Separating_line_group_engraver|cluster-interface|Glissando_engraver|key-signature-interface|clef-interface|VaticanaVoice|Rest_collision_engraver|Grace_engraver|grid-point-interface|Measure_grouping_engraver|Laissez_vibrer_engraver|Script_row_engraver|bass-figure-alignment-interface|Note_head_line_engraver|ottava-bracket-interface|rhythmic-head-interface|Accidental_engraver|Mark_engraver|hara-kiri-group-interface|Instrument_name_engraver|Vaticana_ligature_engraver|Page_turn_engraver|staff-symbol-interface|Beam_performer|accidental-suggestion-interface|Key_engraver|GrandStaff|multi-measure-interface|rest-collision-interface|Dot_column_engraver|MensuralVoice|TabStaff|Pitched_trill_engraver|line-spanner-interface|Time_signature_performer|lyric-interface|StaffGroup|text-interface|slur-interface|Drum_note_performer|TabVoice|measure-grouping-interface|stanza-number-interface|self-alignment-interface|Span_arpeggio_engraver|system-interface|Engraver|RhythmicStaff|font-interface|fret-diagram-interface|Grace_spacing_engraver|Bar_engraver|Dynamic_engraver|Grob_pq_engraver|Default_bar_line_engraver|Swallow_performer|script-column-interface|Piano_pedal_performer|metronome-mark-interface|melody-spanner-interface|FretBoards|spacing-spanner-interface|Control_track_performer|Break_align_engraver|paper-column-interface|PianoStaff|Breathing_sign_engraver|accidental-placement-interface|Tuplet_engraver|stroke-finger-interface|side-position-interface|note-name-interface|bar-line-interface|lyric-extender-interface|Staff|GregorianTranscriptionStaff|Rest_swallow_translator|dynamic-text-spanner-interface|arpeggio-interface|Cluster_spanner_engraver|Collision_engraver|accidental-interface|rest-interface|Tab_note_heads_engraver|dots-interface|staff-symbol-referencer-interface|ambitus-interface|bass-figure-interface|vaticana-ligature-interface|ledgered-interface|item-interface|Tie_performer|volta-bracket-interface|vertically-spaceable-interface|ledger-line-interface|Chord_tremolo_engraver|note-column-interface|DrumVoice|axis-group-interface|Ledger_line_engraver|Slash_repeat_engraver|ligature-bracket-interface|Pitch_squash_engraver|Instrument_switch_engraver|Voice|Script_column_engraver|Volta_engraver|Stanza_number_align_engraver|Vertical_align_engraver|span-bar-interface|Staff_collecting_engraver|Ligature_bracket_engraver|Time_signature_engraver|Beam_engraver|Note_name_engraver|Note_heads_engraver|Forbid_line_break_engraver|spacing-options-interface|spacing-interface|Span_dynamic_performer|piano-pedal-script-interface|MensuralStaff|Global|trill-pitch-accidental-interface|grob-interface|Horizontal_bracket_engraver|Grid_line_span_engraver|NoteNames|piano-pedal-interface|Axis_group_engraver|Staff_symbol_engraver|stem-interface|Slur_engraver|pitched-trill-interface|tie-column-interface|stem-tremolo-interface|Grid_point_engraver|System_start_delimiter_engraver|Completion_heads_engraver|Drum_notes_engraver|Swallow_engraver|Slur_performer|lyric-hyphen-interface|Clef_engraver|dynamic-interface|Output_property_engraver|Score|Repeat_tie_engraver|Rest_engraver|break-aligned-interface|String_number_engraver|only-prebreak-interface|Lyric_engraver|Tempo_performer|Parenthesis_engraver|Repeat_acknowledge_engraver|mensural-ligature-interface|align-interface|Stanza_number_engraver|system-start-delimiter-interface|lyric-syllable-interface|bend-after-interface|dynamic-line-spanner-interface|Staff_performer|Bar_number_engraver|Fretboard_engraver|tablature-interface|Fingering_engraver|chord-name-interface|Note_swallow_translator|Chord_name_engraver|note-head-interface|breathing-sign-interface|Extender_engraver|Ambitus_engraver|DrumStaff|dot-column-interface|Lyric_performer|enclosing-bracket-interface|Trill_spanner_engraver|Key_performer|Vertically_spaced_contexts_engraver|hairpin-interface|Hyphen_engraver|Dots_engraver|multi-measure-rest-interface|break-alignment-align-interface|Multi_measure_rest_engraver|InnerStaffGroup|text-spanner-interface|Grace_beam_engraver|separation-item-interface|Translator|separation-spanner-interface|Tweak_engraver|Devnull|Bend_after_engraver|Spacing_engraver|Piano_pedal_align_engraver|system-start-text-interface|parentheses-interface|Melisma_translator|ChoirStaff|Span_bar_engraver|Text_engraver|GregorianTranscriptionVoice|Timing_translator|script-interface|semi-tie-interface|Percent_repeat_engraver|Tab_staff_symbol_engraver|line-interface|rhythmic-grob-interface|Dynamic_performer|note-spacing-interface|spanner-interface|break-alignment-interface|tuplet-number-interface|Rhythmic_column_engraver|cluster-beacon-interface|horizontal-bracket-interface|Mensural_ligature_engraver|ChordNames|gregorian-ligature-interface|Melody_engraver|ligature-interface|Paper_column_engraver|FiguredBass|grace-spacing-interface|tie-interface|New_fingering_engraver|Script_engraver|Metronome_mark_engraver|string-number-interface|Hara_kiri_engraver|grid-line-interface|Skip_event_swallow_translator|Auto_beam_engraver|spaceable-grob-interface|Font_size_engraver|figured-bass-continuation-interface|semi-tie-column-interface|CueVoice|Phrasing_slur_engraver|InnerChoirStaff|Arpeggio_engraver|mark-interface|VaticanaStaff|piano-pedal-bracket-interface|beam-interface|Note_performer|custos-interface|percent-repeat-interface|time-signature-interface|Custos_engraver|Part_combine_engraver|Piano_pedal_engraver|tuplet-bracket-interface|Stem_engraver|finger-interface|note-collision-interface|Text_spanner_engraver|text-balloon-interface|Tie_engraver|Figured_bass_position_engraver)( |=|<|.)/g, output : '<span>$1</span>$2'}, // Contexts, Engravers, Interfaces (ok, this line could be shorter...)
	{ input : /([0-9]|breve|longa|maxima)(\.?)/g, output : '<s>$1</s>$2' }, // digits and durations
	{ input : /\\(override|version|include|invalid|addquote|alternative|book|~|mark|default|key|skip|octave|partial|time|clef|change|consists|remove|accepts|defaultchild|denies|alias|type|description|name|context|grobdescriptions|markup|header|notemode|drummode|figuremode|chordmode|lyricmode|drums|figures|chords|lyrics|once|revert|set|unset|addlyrics|objectid|with|rest|paper|midi|layout|new|times|transpose|tag|relative|renameinput|repeat|lyricsto|score|sequential|simultaneous|longa|breve|maxima|tempo)/g, output : '<cite>\\$1</cite>' }, // music commands
	{ input : /\\(AncientRemoveEmptyStaffContext|RemoveEmptyRhythmicStaffContext|RemoveEmptyStaffContext|accent|aeolian|afterGraceFraction|aikenHeads|allowPageTurn|arpeggio|arpeggioBracket|arpeggioDown|arpeggioNeutral|arpeggioUp|autoBeamOff|autoBeamOn|between-system-padding|between-system-space|bigger|blackTriangleMarkup|bookTitleMarkup|bracketCloseSymbol|bracketOpenSymbol|break|breve|cadenzaOff|cadenzaOn|center|chordmodifiers|cm|coda|cr|cresc|decr|dim|dorian|dotsDown|dotsNeutral|dotsUpdown|downbow|downmordent|downprall|drumPitchNames|dutchPitchnames|dynamicDown|dynamicNeutral|dynamicUp|emptyText|endcr|endcresc|enddecr|enddim|endincipit|escapedBiggerSymbol|escapedExclamationSymbol|escapedParenthesisCloseSymbol|escapedParenthesisOpenSymbol|escapedSmallerSymbol|espressivo|evenHeaderMarkup|f|fatText|fermata|fermataMarkup|ff|fff|ffff|first-page-number|flageolet|fp|frenchChords|fullJazzExceptions|fz|germanChords|glissando|harmonic|hideNotes|hideStaffSwitch|ignatzekExceptionMusic|ignatzekExceptions|improvisationOff|improvisationOn|in|input-encoding|instrument-definitions|ionian|italianChords|laissezVibrer|left|lheel|lineprall|locrian|longa|longfermata|ltoe|lydian|major|marcato|maxima|melisma|melismaEnd|mf|midiDrumPitches|minor|mixolydian|mm|mordent|mp|newSpacingSection|noBeam|noBreak|noPageBreak|noPageTurn|normalsize|oddFooterMarkup|oddHeaderMarkup|oneVoice|open|output-scale|p|page-top-space|pageBreak|pageTurn|parenthesisCloseSymbol|parenthesisOpenSymbol|partialJazzExceptions|partialJazzMusic|phrasingSlurDown|phrasingSlurNeutral|phrasingSlurUp|phrygian|pipeSymbol|pitchnames|portato|pp|ppp|pppp|ppppp|prall|pralldown|prallmordent|prallprall|prallup|print-first-page-number|print-page-number|pt|ragged-bottom|ragged-last-bottom|repeatTie|reverseturn|rfz|rheel|right|rtoe|sacredHarpHeads|scoreTitleMarkup|segno|semiGermanChords|setDefaultDurationToQuarter|setEasyHeads|setHairpinCresc|setHairpinDecresc|setHairpinDim|setTextCresc|setTextDecresc|setTextDim|sf|sff|sfp|sfz|shiftOff|shiftOn|shiftOnn|shiftOnnn|shortfermata|showStaffSwitch|signumcongruentiae|slashSeparator|slurDashed|slurDotted|slurDown|slurNeutral|slurSolid|slurUp|small|smaller|sostenutoDown|sostenutoUp|sp|spp|staccatissimo|staccato|start|startAcciaccaturaMusic|startAppoggiaturaMusic|startGraceMusic|startGroup|startStaff|startTextSpan|startTrillSpan|stemDown|stemNeutral|stemUp|stop|stopAcciaccaturaMusic|stopAppoggiaturaMusic|stopGraceMusic|stopGroup|stopStaff|stopTextSpan|stopTrillSpan|stopped|sustainDown|sustainUp|tagline|tenuto|textSpannerDown|textSpannerNeutral|textSpannerUp|thumb|tieDashed|tieDotted|tieDown|tieNeutral|tieSolid|tieUp|tildeSymbol|tiny|treCorde|trill|tupletDown|tupletNeutral|tupletUp|turn|unHideNotes|unaCorda|unit|up|upbow|upmordent|upprall|varcoda|verylongfermata|voiceFour|voiceOne|voiceThree|voiceTwo|whiteTriangleMarkup)( |=|<|.)/g, output : '<identifier>\\$1</identifier>$2'}, //identifiers
	{ input : /\\(acciaccatura|addInstrumentDefinition|addquote|afterGrace|applyContext|applyMusic|applyOutput|appoggiatura|assertBeamQuant|assertBeamSlope|autochange|balloonGrobText|balloonText|bar|barNumberCheck|bendAfter|breathe|compressMusic|cueDuring|displayLilyMusic|displayMusic|featherDurations|grace|includePageLayoutFile|instrumentSwitch|keepWithTag|killCues|makeClusters|musicMap|octave|oldaddlyrics|overrideProperty|parallelMusic|parenthesize|partcombine|pitchedTrill|quoteDuring|removeWithTag|resetRelativeOctave|rightHandFinger|scoreTweak|shiftDurations|spacingTweaks|tag|transposedCueDuring|transposition|tweak|unfoldRepeats|withMusicProperty)/g, output : '<ins>\\$1</ins>' }, // music functions
	{ input : /\\(arrow-head|beam|bigger|bold|box|bracket|bracketed-y-column|caps|center-align|char|circle|column|combine|dir-column|doubleflat|doublesharp|draw-circle|dynamic|epsfile|fill-line|filled-box|finger|flat|fontsize|fraction|fret-diagram|fret-diagram-terse|fret-diagram-verbose|fromproperty|general-align|halign|hbracket|hcenter|hcenter-in|hspace|huge|italic|justify|justify-field|justify-string|large|left-align|line|lookup|lower|magnify|markalphabet|markletter|medium|musicglyph|natural|normal-size-sub|normal-size-super|normal-text|normalsize|note|note-by-number|null|number|on-the-fly|pad-around|pad-markup|pad-to-box|pad-x|postscript|put-adjacent|raise|right-align|roman|rotate|sans|score|semiflat|semisharp|sesquiflat|sesquisharp|sharp|simple|slashed-digit|small|smallCaps|smaller|stencil|strut|sub|super|teeny|text|tied-lyric|tiny|translate|translate-scaled|transparent|triangle|typewriter|upright|vcenter|verbatim-file|whiteout|with-color|with-dimensions|with-url|wordwrap|wordwrap-field|wordwrap-string|\|,)( |=|<|.)/g, output : '<strong>\\$1</strong>$2' }, // markup commands
	{ input : /(#[a-z|A-Z|:\|]+) /g, output : '<a>$1</a>' }, //scheme
	{ input : /(#?[\(\|][a-z|A-Z])(.*?)(<br|<\/P)/g, output : '<a>$1$2</a>$3' } //scheme
]
Language.snippets = [
	{ input : '\score', output : '\score {\n\t\n\t\\layout{}\n\t\\midi{}\n\t}' }
	]
	
	
Language.complete = [
	{ input : '"', output : '"$0"' },
	{ input : /([^%\{])/g, output : '{\n\t$1\n}' }
]

Language.shortcuts = [
	{ input : '[space]', output : '&nbsp;' },
	{ input : '[enter]', output : '<br />' } 
]